Subject: Re: [PATCH 4/4] RFC: net: dsa: realtek-smi: Add Realtek SMI driver

From: Andrew Lunn <[email-masked]>
Date: Thu, 9 Nov 2017 14:24:00 +0100

> Although it could be a good thing to bring this to mainline, I'm kind of
> pessimistic about supporting such switches in DSA/switchdev. IMO swconfig
> does a better job for now.

I think the important point here is "... for now"

> Unless switchdev could be expanded to support other functions beyond VLAN,
> like port rate control, ACL, HW NAT (no switchdev L3 offload doesn't fit
> this), etc.

Switchdev allows offloading of TC. So port rate control would be
implemented via TC. By ACL do you mean filtering MAC addresses?
iptables? The Broadcom SF2 allows some access to its TCAM using
standard methods. More will come with time. Offload of iptables is in
the works. Pablo posted some patches this month laying the foundations
of HW NAT.

What you request are in the works.

What should also be considered is who is pushing swithdev and DSA
forward, and for what market.

Pure switchdev drivers is mostly being pushed forward for Top or Rack
switches. Big switches, 10G, 40G, 100G ports and lots of them. L3
routing, etc.

switchdev/DSA is mostly being pushed forward by industrial
applications. Switches in big vehicles, trains, planes. Industrial
plant control.

The people pushing stuff forward currently have your list of features
as Nice to Have, so progress is slow in that area. It needs somebody
who cares about these features, needs these features, to dig in and do
the work.

    Andrew